Subject: bug#66328: 29.1; Incompatible change to `completing-read' breaks existing code

From: Stephen Berman <[email-masked]>
Date: Wed, 04 Oct 2023 01:25:20 +0200

On Tue, 3 Oct 2023 22:11:41 +0000 Drew Adams <[email-masked]> wrote:

> How did the signature of `completing-read' get changed?  I didn't notice
> any proposal or discussion about this in [email-masked].  Did I
> just miss it somehow?
>
> It used to be that _any_ REQUIRE-MATCH value that is not `t', nil,
> `confirm', or `confirm-after-completion' behaves like `t', except that
> type RET doesn't exit if what you type does non-null completion.
>
> That's no longer true if the value is a function!  This completely
> changes the behavior of `completing-read'.
>
> Not happy with the result, and not happy with how the process - how this
> was done, if it wasn't discussed openly in emacs-devel.

There was a short discussion, after the change was made, starting here:
https://lists.gnu.org/archive/html/emacs-devel/2022-06/msg00539.html

Steve Berman